package me.hammerle.snuviengine;

import me.hammerle.snuviengine.api.Gamepad;
import me.hammerle.snuviengine.api.Renderer;
import me.hammerle.snuviengine.api.Game;
import me.hammerle.snuviengine.api.Keys;
import me.hammerle.snuviengine.api.Stats;

public class TestGame implements Game {
    private float posX = 200.0f;
    private float posY = 0.0f;
    private float lastPosX = 0.0f;
    private float lastPosY = 0.0f;
    private float move = 16.5f;
    private final float size = 20.0f;

    private Stats stats = null;
    private Gamepad gamepad = null;

    @Override
    public void onCompleteInitialization(Stats stats, Keys keys, Gamepad gamepad) {
        this.stats = stats;
        this.gamepad = gamepad;
    }

    @Override
    public void tick() {
        lastPosX = posX;
        lastPosY = posY;
        posX += move;
        if(posX < 0.0f || posX > 250.0f) {
            move = -move;
        }
    }

    private boolean toggle;

    @Override
    public void renderTick(Renderer renderer, float lag) {
        toggle = !toggle;
        renderer.translateTo(0.0f, 0.0f);
        renderer.updateMatrix();
        float y = 10;
        renderer.setColorEnabled(true);
        renderer.setTextureEnabled(true);
        y = renderer.getFontRenderer().drawString(10, y, true, String.format("F##ÜP__@S: #00FF00%.1f", stats.getFramesPerSecond()));
        y = renderer.getFontRenderer().drawString(10, y, true, String.format("T/\\VPS: %.1f", stats.getTicksPerSecond()));
        for(Gamepad.Button binding : gamepad.bindings) {
            y = renderer.getFontRenderer().drawString(10, y, true, String.format("%s: %b, %d, %b", binding.getName(), binding.isDown(), binding.getTime(), binding.isReleased()));
        }
        renderer.setColorEnabled(true);
        renderer.setTextureEnabled(false);
        float rx = lastPosX + (posX - lastPosX) * lag;
        float ry = lastPosY + (posY - lastPosY) * lag;
        rx = renderer.round(rx);
        ry = renderer.round(ry);
        renderer.translateTo(rx, ry);
        renderer.updateMatrix();
        renderer.getColorRenderer().drawRectangle(0, 0, size, size, 0xFF0000FF);
    }

    @Override
    public void onStop() {
    }
}
