package me.hammerle.snuviengine.api;

import java.util.HashMap;
import static org.lwjgl.glfw.GLFW.*;

public final class KeyNames {
    private final static HashMap<Integer, String> NAMES = new HashMap<>();

    static {
        NAMES.put(GLFW_KEY_UP, "Up");
        NAMES.put(GLFW_KEY_DOWN, "Down");
        NAMES.put(GLFW_KEY_LEFT, "Left");
        NAMES.put(GLFW_KEY_RIGHT, "Right");
        NAMES.put(GLFW_KEY_LEFT_SHIFT, "L-Shift");
        NAMES.put(GLFW_KEY_RIGHT_SHIFT, "R-Shift");
        NAMES.put(GLFW_KEY_ESCAPE, "Escape");
        NAMES.put(GLFW_KEY_ENTER, "Enter");
        NAMES.put(GLFW_KEY_SPACE, "Space");
        NAMES.put(GLFW_KEY_WORLD_2, "World 2");
        NAMES.put(GLFW_KEY_TAB, "Tab");
        NAMES.put(GLFW_KEY_BACKSPACE, "Backspace");
        NAMES.put(GLFW_KEY_INSERT, "Insert");
        NAMES.put(GLFW_KEY_DELETE, "Delete");
        NAMES.put(GLFW_KEY_PAGE_UP, "Page Up");
        NAMES.put(GLFW_KEY_PAGE_DOWN, "Page Down");
        NAMES.put(GLFW_KEY_HOME, "Home");
        NAMES.put(GLFW_KEY_END, "End");
        NAMES.put(GLFW_KEY_CAPS_LOCK, "Caps Lock");
        NAMES.put(GLFW_KEY_SCROLL_LOCK, "Scroll Lock");
        NAMES.put(GLFW_KEY_NUM_LOCK, "Num Lock");
        NAMES.put(GLFW_KEY_PRINT_SCREEN, "Print Screen");
        NAMES.put(GLFW_KEY_PAUSE, "Pause");
        NAMES.put(GLFW_KEY_F1, "F1");
        NAMES.put(GLFW_KEY_F2, "F2");
        NAMES.put(GLFW_KEY_F3, "F3");
        NAMES.put(GLFW_KEY_F4, "F4");
        NAMES.put(GLFW_KEY_F5, "F5");
        NAMES.put(GLFW_KEY_F6, "F6");
        NAMES.put(GLFW_KEY_F7, "F7");
        NAMES.put(GLFW_KEY_F8, "F8");
        NAMES.put(GLFW_KEY_F9, "F9");
        NAMES.put(GLFW_KEY_F10, "F10");
        NAMES.put(GLFW_KEY_F11, "F11");
        NAMES.put(GLFW_KEY_F12, "F12");
        NAMES.put(GLFW_KEY_F13, "F13");
        NAMES.put(GLFW_KEY_F14, "F14");
        NAMES.put(GLFW_KEY_F15, "F15");
        NAMES.put(GLFW_KEY_F16, "F16");
        NAMES.put(GLFW_KEY_F17, "F17");
        NAMES.put(GLFW_KEY_F18, "F18");
        NAMES.put(GLFW_KEY_F19, "F19");
        NAMES.put(GLFW_KEY_F20, "F20");
        NAMES.put(GLFW_KEY_F21, "F21");
        NAMES.put(GLFW_KEY_F22, "F22");
        NAMES.put(GLFW_KEY_F23, "F23");
        NAMES.put(GLFW_KEY_F24, "F24");
        NAMES.put(GLFW_KEY_F25, "F25");
        NAMES.put(GLFW_KEY_KP_ENTER, "Keypad Enter");
        NAMES.put(GLFW_KEY_LEFT_CONTROL, "L-Control");
        NAMES.put(GLFW_KEY_LEFT_ALT, "L-Alt");
        NAMES.put(GLFW_KEY_LEFT_SUPER, "L-Super");
        NAMES.put(GLFW_KEY_RIGHT_CONTROL, "R-Control");
        NAMES.put(GLFW_KEY_RIGHT_ALT, "R-Alt");
        NAMES.put(GLFW_KEY_RIGHT_SUPER, "R-Super");
        NAMES.put(GLFW_KEY_MENU, "Menu");
        NAMES.put(GLFW_KEY_LAST, "Last");
    }

    public static String getName(int key) {
        String name = NAMES.get(key);
        if(name != null) {
            return name;
        }
        name = glfwGetKeyName(key, glfwGetKeyScancode(key));
        if(name != null) {
            return name.substring(0, 1).toUpperCase() + name.substring(1);
        }
        return "Unknown";
    }
}
