package me.hammerle.snuviengine.api;

public class ResizingWindowView implements WindowView {
    private final int minWidth;
    private final int minHeight;

    public ResizingWindowView(int minWidth, int minHeight) {
        this.minWidth = minWidth;
        this.minHeight = minHeight;
    }

    @Override
    public int getScale(int width, int height) {
        int scale = 1;
        while(width / (scale + 1) >= minWidth && height / (scale + 1) >= minHeight) {
            scale++;
        }
        return scale;
    }

    @Override
    public int getFontScale(int width, int height) {
        return getScale(width, height);
    }
}
