package me.hammerle.snuviengine.api;

import static org.lwjgl.opengl.GL20.glGetUniformLocation;
import static org.lwjgl.opengl.GL20.glUniform1i;

public class UniformBoolean {
    private final int location;
    private boolean value;

    public UniformBoolean(int program, String name, boolean value) {
        location = glGetUniformLocation(program, name);
        setUnchecked(value);
    }

    private void setUnchecked(boolean value) {
        this.value = value;
        glUniform1i(location, value ? 1 : 0);
    }

    public void set(boolean value) {
        if(this.value != value) {
            setUnchecked(value);
        }
    }
}
